<template>
  <v-alert
      v-if="success"
      type="success"
      closable
      title="กรุณาตรวจสอบกล่องจดหมายในอีเมลของท่าน"
  />
  <div class="container">
    <v-card class="card">
      <div class="lo-icon">
        <v-btn variant="text" icon="mdi-arrow-left" to="/login"></v-btn>
      </div>

      <h2 class="text-center mb-6">ยืนยันที่อยู่อีเมล</h2>
      <v-form @submit.prevent="onSubmit">
        <v-text-field
            v-model="email"
            :rules="[emailRules.required, emailRules.check]"
            ref="emailField"
            label="อีเมล"
            placeholder="example@rmuti.ac.th"
            variant="solo"
            rounded="xl"
            density="comfortable"
            clearable
            type="email"
        ></v-text-field>

        <v-btn
            :loading="loading"
            :disabled="!isFormValid"
            type="submit"
            block
            class="submit-btn"
            size="large"
            variant="flat"
            rounded="xl"
        >ยืนยัน
        </v-btn
        >
      </v-form>
    </v-card>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | ยืนยันที่อยู่อีเมล",
  meta: [{name: "description", content: "การยืนยันที่อยู่อีเมล"}],
});
// ปิด layout
definePageMeta({
  layout: false,
});

import {ref} from "vue";
const {sendEmailConfirmation} = useStrapiAuth()

const email = ref();
const loading = ref(false);
const success = ref(false);

const emailRules = {
  required: (value) => !!value || "กรุณากรอกที่อยู่อีเมล",
  check: (value) => {
    const pattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
    const domain = "@rmuti.ac.th";
    if (!value) return true; 
    if (!pattern.test(value)) return "รูปแบบอีเมลไม่ถูกต้อง"; 
    if (!value.endsWith(domain)) return `ที่อยู่อีเมลต้องเป็น @rmuti.ac.th`;
    return true;
  },
};

const isFormValid = computed(() => {
  return (!!email.value && isemailValid(email.value)
  );
});

const isemailValid = (value) => value && value.endsWith("@rmuti.ac.th");

const onSubmit = async () => {
  loading.value = true
  setTimeout(() => (loading.value = false), 3000)
  try {
    await sendEmailConfirmation({email: email.value})
        .then(() => {
          success.value = true
          setTimeout(() => (success.value = false), 3000)
        })
        .catch(error => {
          console.error('An error occurred : ', error.response);
        });
  } catch (error) {
    console.error('An error occurred : ', error.response);
  }
}
</script>

<style scoped>
@import url(../assets/css/styles/form-card.css);
</style>